DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - New Record Position

The DevExtreme JavaScript DataGrid API includes a newRowPosition property. With this property, you can specify the desired "new record" position as follows.

Backend API
$(() => { const newRowPositionOptions = ['first', 'last', 'pageTop', 'pageBottom', 'viewportTop', 'viewportBottom']; const scrollingModeOptions = ['standard', 'virtual']; const dataGrid = $('#gridContainer').dxDataGrid({ dataSource, showBorders: true, columnAutoWidth: true, editing: { mode: 'row', allowAdding: true, allowDeleting: true, allowUpdating: true, confirmDelete: false, useIcons: true, newRowPosition: 'viewportTop', }, pager: { visible: true, }, remoteOperations: true, columns: [ { dataField: 'OrderID', allowEditing: false, }, { dataField: 'OrderDate', dataType: 'date', validationRules: [{ type: 'required' }], }, 'ShipName', 'ShipCity', 'ShipPostalCode', 'ShipCountry', { type: 'buttons', buttons: [{ icon: 'add', text: 'Add', onClick(e) { const key = new DevExpress.data.Guid().toString(); dataGrid.option('editing.changes', [{ key, type: 'insert', insertAfterKey: e.row.key, }]); dataGrid.option('editing.editRowKey', key); }, visible({ row }) { return !row.isEditing; }, }, 'delete', 'save', 'cancel'], }], toolbar: { items: [{ name: 'addRowButton', showText: 'always', }], }, onRowInserted(e) { e.component.navigateToRow(e.key); }, }).dxDataGrid('instance'); $('#newRowPositionSelectBox').dxSelectBox({ value: 'viewportTop', items: newRowPositionOptions, inputAttr: { 'aria-label': 'Position' }, onValueChanged(e) { dataGrid.option('editing.newRowPosition', e.value); }, }).dxSelectBox('instance'); $('#scrollingModeSelectBox').dxSelectBox({ value: 'standard', items: scrollingModeOptions, inputAttr: { 'aria-label': 'Scrolling Mode' }, onValueChanged(e) { dataGrid.option('scrolling.mode', e.value); }, }).dxSelectBox('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=25.2.7"></script> <script src="https://unpkg.com/devextreme-aspnet-data@5.0.0/js/dx.aspnet.data.js"></script> <script src="/shared/anti-forgery/jquery-override.js"></script> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> <div class="options"> <div class="caption">Options</div> <div class="option-container"> <div class="option"> <span>New Row Position</span> <div id="newRowPositionSelectBox"></div> </div> <div class="option"> <span>Scrolling Mode</span> <div id="scrollingModeSelectBox"></div> </div> </div> </div> </div> </body> </html>
#gridContainer { height: 440px; } .options { margin-top: 20px; padding: 20px; background-color: rgba(191, 191, 191, 0.15); position: relative; } .caption { font-size: 18px; font-weight: 500; } .option-container { display: flex; margin: 0 auto; justify-content: space-between; } .option { margin-top: 10px; display: flex; align-items: center; } .option-caption { white-space: nowrap; margin: 0 8px; } .option > span { position: relative; margin-right: 10px; } #newRowPositionSelectBox { width: 150px; } #scrollingModeSelectBox { width: 150px; }
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi'; const dataSource = DevExpress.data.AspNet.createStore({ key: 'OrderID', loadUrl: `${url}/Orders`, insertUrl: `${url}/InsertOrder`, updateUrl: `${url}/UpdateOrder`, deleteUrl: `${url}/DeleteOrder`, onBeforeSend: (method, ajaxOptions) => { ajaxOptions.xhrFields = { withCredentials: true }; }, });
  • "viewportTop" (default)
    Insert a new row at the top of the viewport.

  • "viewportBottom"
    Insert a new row at the bottom of the viewport.

  • "pageTop"
    Insert a new row at the top of the current page. In virtual and infinite scrolling modes, "pageTop" works like "viewportTop".

  • "pageBottom"
    Insert a new row at the bottom of the current page. In virtual and infinite scrolling modes, "pageBottom" works like "viewportBottom".

  • "first"
    Navigate to the beginning of the dataset and insert a new row at the top.

  • "last"
    Navigate to the end of the dataset and insert a new row at the bottom. Does not apply in infinite scrolling mode.

In this demo, you can use a drop-down menu to change the newRowPosition property value at runtime. To see how your choice affects "new record" position, click the "Add a row" button in the toolbar. This demo also allows you to switch between standard and virtual scrolling modes (you can also see how newRowPosition works with each scrolling mode).

If you wish to position new records in a more flexible manner, you can specify the key before/after which a new record must be inserted. To apply this feature, set the insertBeforeKey or insertAfterKey property in the pending changes array. In this demo, each row contains an "Add row" button that inserts a new row after the current row. The insertAfterKey property is used to implement this functionality. Review the button's onClick event handler for more information.

A new record remains at a specified position until it is saved. Once saved, the DevExtreme JavaScript DataGrid reloads data and sorts all records. As a result, the saved record may appear outside the viewport. To navigate to this record, call the navigateToRow(key) method from the onRowInserted event handler (as illustrated in this demo). As an alternative, you can set the refreshMode to "repaint". In this instance, the record retains its custom position after a save operation (however, position may change once data is shaped in the future).

import React, { useCallback, useState } from 'react';
import DataGrid, {
Column, Editing, ValidationRule, Button, Toolbar, Item, Scrolling, Pager,
} from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import SelectBox from 'devextreme-react/select-box';
import Guid from 'devextreme/core/guid';
import { dataSource, positionLabel, scrollingModeLabel } from './data.ts';
const newRowPositionOptions = ['first', 'last', 'pageTop', 'pageBottom', 'viewportTop', 'viewportBottom'];
const scrollingModeOptions = ['standard', 'virtual'];
const isAddButtonVisible = ({ row }: { row: DataGridTypes.Row }) => !row.isEditing;
const onRowInserted = (e: DataGridTypes.RowInsertedEvent) => {
e.component.navigateToRow(e.key);
};
const App = () => {
const [newRowPosition, setNewRowPosition] = useState<DataGridTypes.NewRowPosition>('viewportTop');
const [scrollingMode, setScrollingMode] = useState<DataGridTypes.DataGridScrollMode>('standard');
const [changes, setChanges] = useState<DataGridTypes.DataChange[]>([]);
const [editRowKey, setEditRowKey] = useState<string | null>(null);
const onAddButtonClick = useCallback((e: DataGridTypes.ColumnButtonClickEvent) => {
const key = new Guid().toString();
setChanges([{
key,
type: 'insert',
insertAfterKey: e.row?.key,
data: {},
}]);
setEditRowKey(key);
}, []);
return (
<>
<DataGrid
id='gridContainer'
dataSource={dataSource}
showBorders={true}
columnAutoWidth={true}
remoteOperations={true}
onRowInserted={onRowInserted}
>
<Scrolling mode={scrollingMode} />
<Editing
mode='row'
allowAdding={true}
allowDeleting={true}
allowUpdating={true}
confirmDelete={false}
useIcons={true}
newRowPosition={newRowPosition}
changes={changes}
onChangesChange={setChanges}
editRowKey={editRowKey}
onEditRowKeyChange={setEditRowKey}
/>
<Pager visible={true} />
<Column dataField='OrderID' allowEditing={false} />
<Column dataField='OrderDate' dataType='date'>
<ValidationRule type='required' />
</Column>
<Column dataField='ShipName' />
<Column dataField='ShipCity' />
<Column dataField='ShipPostalCode' />
<Column dataField='ShipCountry' />
<Column type='buttons'>
<Button icon='add'
text='Add'
onClick={onAddButtonClick}
visible={isAddButtonVisible}
/>
<Button name='delete' />
<Button name='save' />
<Button name='cancel' />
</Column>
<Toolbar>
<Item name='addRowButton' showText='always' />
</Toolbar>
</DataGrid>
<div className='options'>
<div className='caption'>Options</div>
<div className='option-container'>
<div className='option'>
<span>New Row Position</span>
<SelectBox
id='newRowPositionSelectBox'
value={newRowPosition}
inputAttr={positionLabel}
items={newRowPositionOptions}
onValueChange={setNewRowPosition}
/>
</div>
<div className='option'>
<span>Scrolling Mode</span>
<SelectBox
id='scrollingModeSelectBox'
value={scrollingMode}
inputAttr={scrollingModeLabel}
items={scrollingModeOptions}
onValueChange={setScrollingMode}
/>
</div>
</div>
</div>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import DataGrid, {
Column,
Editing,
ValidationRule,
Button,
Toolbar,
Item,
Scrolling,
Pager,
} from 'devextreme-react/data-grid';
import SelectBox from 'devextreme-react/select-box';
import Guid from 'devextreme/core/guid';
import { dataSource, positionLabel, scrollingModeLabel } from './data.js';
const newRowPositionOptions = [
'first',
'last',
'pageTop',
'pageBottom',
'viewportTop',
'viewportBottom',
];
const scrollingModeOptions = ['standard', 'virtual'];
const isAddButtonVisible = ({ row }) => !row.isEditing;
const onRowInserted = (e) => {
e.component.navigateToRow(e.key);
};
const App = () => {
const [newRowPosition, setNewRowPosition] = useState('viewportTop');
const [scrollingMode, setScrollingMode] = useState('standard');
const [changes, setChanges] = useState([]);
const [editRowKey, setEditRowKey] = useState(null);
const onAddButtonClick = useCallback((e) => {
const key = new Guid().toString();
setChanges([
{
key,
type: 'insert',
insertAfterKey: e.row?.key,
data: {},
},
]);
setEditRowKey(key);
}, []);
return (
<>
<DataGrid
id="gridContainer"
dataSource={dataSource}
showBorders={true}
columnAutoWidth={true}
remoteOperations={true}
onRowInserted={onRowInserted}
>
<Scrolling mode={scrollingMode} />
<Editing
mode="row"
allowAdding={true}
allowDeleting={true}
allowUpdating={true}
confirmDelete={false}
useIcons={true}
newRowPosition={newRowPosition}
changes={changes}
onChangesChange={setChanges}
editRowKey={editRowKey}
onEditRowKeyChange={setEditRowKey}
/>
<Pager visible={true} />
<Column
dataField="OrderID"
allowEditing={false}
/>
<Column
dataField="OrderDate"
dataType="date"
>
<ValidationRule type="required" />
</Column>
<Column dataField="ShipName" />
<Column dataField="ShipCity" />
<Column dataField="ShipPostalCode" />
<Column dataField="ShipCountry" />
<Column type="buttons">
<Button
icon="add"
text="Add"
onClick={onAddButtonClick}
visible={isAddButtonVisible}
/>
<Button name="delete" />
<Button name="save" />
<Button name="cancel" />
</Column>
<Toolbar>
<Item
name="addRowButton"
showText="always"
/>
</Toolbar>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option-container">
<div className="option">
<span>New Row Position</span>
<SelectBox
id="newRowPositionSelectBox"
value={newRowPosition}
inputAttr={positionLabel}
items={newRowPositionOptions}
onValueChange={setNewRowPosition}
/>
</div>
<div className="option">
<span>Scrolling Mode</span>
<SelectBox
id="scrollingModeSelectBox"
value={scrollingMode}
inputAttr={scrollingModeLabel}
items={scrollingModeOptions}
onValueChange={setScrollingMode}
/>
</div>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
// eslint-disable-next-line import/no-unresolved
import 'anti-forgery';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export const dataSource = createStore({
key: 'OrderID',
loadUrl: `${url}/Orders`,
insertUrl: `${url}/InsertOrder`,
updateUrl: `${url}/UpdateOrder`,
deleteUrl: `${url}/DeleteOrder`,
onBeforeSend: (method, ajaxOptions) => {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
export const positionLabel = { 'aria-label': 'Position' };
export const scrollingModeLabel = { 'aria-label': 'Scrolling Mode' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
// eslint-disable-next-line import/no-unresolved
import 'anti-forgery';
ReactDOM.render(<App />, document.getElementById('app'));
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export const dataSource = createStore({
key: 'OrderID',
loadUrl: `${url}/Orders`,
insertUrl: `${url}/InsertOrder`,
updateUrl: `${url}/UpdateOrder`,
deleteUrl: `${url}/DeleteOrder`,
onBeforeSend: (method, ajaxOptions) => {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
export const positionLabel = { 'aria-label': 'Position' };
export const scrollingModeLabel = { 'aria-label': 'Scrolling Mode' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option-container {
display: flex;
margin: 0 auto;
justify-content: space-between;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option-caption {
white-space: nowrap;
margin: 0 8px;
}
.option > span {
position: relative;
margin-right: 10px;
}
#newRowPositionSelectBox {
width: 150px;
}
#scrollingModeSelectBox {
width: 150px;
}

<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
[showBorders]="true"
[columnAutoWidth]="true"
[remoteOperations]="true"
(onRowInserted)="onRowInserted($event)"
>
<dxo-data-grid-scrolling [mode]="scrollingMode"></dxo-data-grid-scrolling>
<dxo-data-grid-editing
mode="row"
[allowAdding]="true"
[allowDeleting]="true"
[allowUpdating]="true"
[confirmDelete]="false"
[useIcons]="true"
[newRowPosition]="newRowPosition"
[changes]="changes"
[(editRowKey)]="editRowKey"
></dxo-data-grid-editing>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxi-data-grid-column
dataField="OrderID"
[allowEditing]="false"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="OrderDate" dataType="date">
<dxi-data-grid-validation-rule
type="required"
></dxi-data-grid-validation-rule>
</dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCity"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipPostalCode"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCountry"></dxi-data-grid-column>
<dxi-data-grid-column type="buttons">
<dxi-data-grid-button
icon="add"
text="Add"
[onClick]="onAddButtonClick"
[visible]="isAddButtonVisible"
></dxi-data-grid-button>
<dxi-data-grid-button name="delete"></dxi-data-grid-button>
<dxi-data-grid-button name="save"></dxi-data-grid-button>
<dxi-data-grid-button name="cancel"></dxi-data-grid-button>
</dxi-data-grid-column>
<dxo-data-grid-toolbar>
<dxi-data-grid-item
name="addRowButton"
showText="always"
></dxi-data-grid-item>
</dxo-data-grid-toolbar>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option-container">
<div class="option">
<span>New Row Position</span>
<dx-select-box
id="newRowPositionSelectBox"
[(value)]="newRowPosition"
[inputAttr]="{ 'aria-label': 'Position' }"
[items]="newRowPositionOptions"
></dx-select-box>
</div>
<div class="option">
<span>Scrolling Mode</span>
<dx-select-box
id="scrollingModeSelectBox"
[inputAttr]="{ 'aria-label': 'Scrolling Mode' }"
[(value)]="scrollingMode"
[items]="scrollingModeOptions"
></dx-select-box>
</div>
</div>
</div>
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { bootstrapApplication, BrowserModule } from '@angular/platform-browser';
import Guid from 'devextreme/core/guid';
import { CustomStore } from 'devextreme-angular/common/data';
import { DxSelectBoxModule } from 'devextreme-angular';
import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
type FirstArgument<T> = T extends (...args: any) => any ? Parameters<T>[0] : never;
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
BrowserModule,
DxDataGridModule,
DxSelectBoxModule,
],
})
export class AppComponent {
dataSource: CustomStore;
newRowPosition: DxDataGridTypes.NewRowPosition = 'viewportTop';
scrollingMode: DxDataGridTypes.DataGridScrollMode = 'standard';
changes = [];
editRowKey = null;
newRowPositionOptions: DxDataGridTypes.NewRowPosition[] = ['first', 'last', 'pageTop', 'pageBottom', 'viewportTop', 'viewportBottom'];
scrollingModeOptions: DxDataGridTypes.DataGridScrollMode[] = ['standard', 'virtual'];
constructor(service: Service) {
this.dataSource = service.getDataSource();
}
onAddButtonClick = ({ row }: DxDataGridTypes.ColumnButtonClickEvent) => {
const key = new Guid().toString();
this.changes = [{
key,
type: 'insert',
insertAfterKey: row.key,
}];
this.editRowKey = key;
};
isAddButtonVisible({ row }: FirstArgument<DxDataGridTypes.ColumnButton['visible']>) {
return !row.isEditing;
}
async onRowInserted(e: DxDataGridTypes.RowInsertedEvent) {
await e.component.navigateToRow(e.key);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#gridContainer {
height: 440px;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option-container {
display: flex;
margin: 0 auto;
justify-content: space-between;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option-caption {
white-space: nowrap;
margin: 0 8px;
}
.option > span {
position: relative;
margin-right: 10px;
}
#newRowPositionSelectBox {
width: 150px;
}
#scrollingModeSelectBox {
width: 150px;
}
import { Injectable } from '@angular/core';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import 'anti-forgery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const dataSource = createStore({
key: 'OrderID',
loadUrl: `${url}/Orders`,
insertUrl: `${url}/InsertOrder`,
updateUrl: `${url}/UpdateOrder`,
deleteUrl: `${url}/DeleteOrder`,
onBeforeSend: (method, ajaxOptions) => {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
@Injectable()
export class Service {
getDataSource() {
return dataSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<DxDataGrid
id="gridContainer"
:data-source="dataSource"
:show-borders="true"
:column-auto-width="true"
:remote-operations="true"
:on-row-inserted="onRowInserted"
>
<DxScrolling
:mode="scrollingMode"
/>
<DxPager :visible="true"/>
<DxEditing
mode="row"
:allow-adding="true"
:allow-deleting="true"
:allow-updating="true"
:confirm-delete="false"
:use-icons="true"
:new-row-position="newRowPosition"
:changes="changes"
:edit-row-key="editRowKey"
/>
<DxColumn
data-field="OrderID"
:allow-editing="false"
/>
<DxColumn
data-field="OrderDate"
data-type="date"
>
<DxValidationRule type="required"/>
</DxColumn>
<DxColumn data-field="ShipName"/>
<DxColumn data-field="ShipCity"/>
<DxColumn data-field="ShipPostalCode"/>
<DxColumn data-field="ShipCountry"/>
<DxColumn type="buttons">
<DxButton
icon="add"
text="Add"
@click="onAddButtonClick"
:visible="isAddButtonVisible"
/>
<DxButton name="delete"/>
<DxButton name="save"/>
<DxButton name="cancel"/>
</DxColumn>
<DxToolbar>
<DxItem
name="addRowButton"
show-text="always"
/>
</DxToolbar>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option-container">
<div class="option">
<span>New Row Position</span>
<DxSelectBox
id="newRowPositionSelectBox"
:input-attr="{ 'aria-label': 'Position' }"
v-model:value="newRowPosition"
:items="newRowPositionOptions"
/>
</div>
<div class="option">
<span>Scrolling Mode</span>
<DxSelectBox
id="scrollingModeSelectBox"
v-model:value="scrollingMode"
:input-attr="{ 'aria-label': 'Scrolling Mode' }"
:items="scrollingModeOptions"
/>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxDataGrid, {
DxColumn,
DxEditing,
DxValidationRule,
DxButton,
DxToolbar,
DxItem,
DxPager,
DxScrolling,
type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import DxSelectBox from 'devextreme-vue/select-box';
import Guid from 'devextreme/core/guid';
import { dataSource } from './data.ts';
const newRowPositionOptions: DxDataGridTypes.NewRowPosition[] = ['first', 'last', 'pageTop', 'pageBottom', 'viewportTop', 'viewportBottom'];
const scrollingModeOptions = ['standard', 'virtual'];
const newRowPosition = ref(newRowPositionOptions[4]);
const scrollingMode = ref<DxDataGridTypes.DataGridScrollMode>('standard');
const changes = ref<DxDataGridTypes.DataChange[]>([]);
const editRowKey = ref<string | null>(null);
const onAddButtonClick = (e: DxDataGridTypes.ColumnButtonClickEvent) => {
const key = new Guid().toString();
changes.value = [{
key,
type: 'insert',
data: {},
insertAfterKey: e.row!.key,
}];
editRowKey.value = key;
};
const isAddButtonVisible = (e: { row: DxDataGridTypes.Row }) => !e.row.isEditing;
const onRowInserted = (e: DxDataGridTypes.RowInsertedEvent) => {
e.component.navigateToRow(e.key);
};
</script>
<style scoped>
#gridContainer {
height: 440px;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option-container {
display: flex;
margin: 0 auto;
justify-content: space-between;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option-caption {
white-space: nowrap;
margin: 0 8px;
}
.option > span {
position: relative;
margin-right: 10px;
}
#newRowPositionSelectBox {
width: 150px;
}
#scrollingModeSelectBox {
width: 150px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export const dataSource = createStore({
key: 'OrderID',
loadUrl: `${url}/Orders`,
insertUrl: `${url}/InsertOrder`,
updateUrl: `${url}/UpdateOrder`,
deleteUrl: `${url}/DeleteOrder`,
onBeforeSend: (method, ajaxOptions) => {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
import { createApp } from 'vue';
import App from './App.vue';
import 'anti-forgery';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>